; #####################################################################################################
; # This file is specific to flurry, all the preview window code is contained in Flurry.bb
; #####################################################################################################
Type Snow
	Field X#
	Field Y#
	Field D ; Direction
	Field F ; Frame
	Field T ; Timer
	Field C ; Color
	Field I#; Inertia
	Field K ; Kind
	Field ID# ; Interia Direction
	Field S ; Size
End Type

Type Burst
	Field X#
	Field Y#
	Field XS# ; XInertia
	Field YS# ; YInertia
	Field B ; Color
	Field S
End Type

Type Bank
	Field X#
	Field Y#
	Field C ; Color
	Field S ; Size
	Field L ; Lifetime
	Field T ; Timer
	Field F ; Fall?
End Type

; #####################################################################################################
; # Flurry Main (Put your screensaver code in here)
; #####################################################################################################
Function Run()
AppTitle "Flurry"
Graphics 640, 480, 16, 1
SetBuffer BackBuffer() ; Images are Parsed
SeedRnd(MilliSecs())

MTime = CreateTimer(60)
MoveMouse 0, 0
While MouseX() + MouseY() = 0
	Cls

	RSky()
	CSnow()
	DrawImage Back, 0, 265
	DrawImage Tree1, 45, 45
	DrawImage Tree2, 410, 160
	DrawImage Snowman, 217, 290
	RBank() 
	RSnow()
	RBurst()

	WaitTimer MTime
	Flip False

Wend: End

End Function

; #####################################################################################################
; # Flurry Functions
; #####################################################################################################
Function RSky() ; Render Sky
B = 0 ; Blue
For Y = 40 To 345 Step 10
	Color 0, 0, B
	Rect 0, Y, 640, 10, 1 
	B = B + 10
	If B >= 255 Then B = 255
Next
End Function

Function CSnow()
s.Snow = New Snow
	s\X = Rand(0, 639)
	s\K = Rand(0, 20)
	s\D = Rand(0, 1)
	If s\K = 10 Then 
		s\F = 0
		s\Y = -30
	Else
		s\Y = -1
	EndIf
	s\T = MilliSecs()
	s\C = Rand(90, 255)
	s\I = 1
	s\ID = Rnd(-.5, -1)
	s\S = Rand(1, 2)
	Parts = Parts + 1
End Function

Function CBurst(X, Y, Num)
For I = 0 To Num
	b.Burst = New burst
	b\X = X
	b\Y = Y
	b\XS = -Sin(Rand(0, 359)) * Rnd(.5, 1.5)
	b\YS = Cos(Rand(0, 359)) * Rnd(.5, 1.5)
	b\B = 255
	b\S = 2
	Parts = Parts + 1
Next
End Function
	
Function AddBank(X, Y, C, S)
a.Bank = New Bank
a\X = X
a\Y = Y
a\C = C
a\S = S
Parts = Parts + 1
a\L = Rand(2000, 7000)
a\T = MilliSecs()
a\F = 0
End Function

Function RSnow()
For s.Snow = Each Snow
	If s\D = 0 Then ; Left
		s\X = s\X - s\I
		s\I = s\I - .01
		If s\I <= s\ID Then s\D = 1: s\I = 1
	EndIf
	
	If s\D = 1 Then ; Right
		s\X = s\X + s\I
		s\I = s\I - .01
		If s\I <= s\ID Then s\D = 0: s\I = 1
	EndIf
	
	s\Y = s\Y + 1
	
	If s\K = 10 Then ; Flake Image
		DrawImage Flake, s\X, s\Y, s\F
		If MilliSecs() >= s\T + 200 Then s\F = s\F + 1: s\T = MilliSecs()
		If s\F = 2 Then s\F = 0
		If ImagesCollide(Flake, s\X, s\Y, s\F, Tree1, 45, 45, 0) Then Del = 1
		If ImagesCollide(Flake, s\X, s\Y, s\F, Tree2, 410, 160, 0) Then Del = 1
		If ImagesCollide(Flake, s\X, s\Y, s\F, Snowman, 217, 290, 0) Then Del = 1
		If Del = 1 Then CBurst(s\X, s\Y, 50)
	Else
		Color s\C, s\C, s\C
		Rect s\X, s\Y, s\S, s\S, 1
		If Parts < 1000 ; Limit 
			If ImageRectCollide(Tree1, 45, 45, 0, s\X, s\Y, s\S, s\S) Then AddBank(s\X, s\Y, s\C, s\S): Del = 1
			If ImageRectCollide(Tree2, 410, 160, 0, s\X, s\Y, s\S, s\S) Then AddBank(s\X, s\Y, s\C, s\S): Del = 1
		EndIf
	EndIf
	
	If s\Y > 480 Or Del = 1 Then Delete s: Parts = Parts - 1
	Del = 0
Next
End Function

Function RBurst()
For b.Burst = Each Burst
	b\X = b\X - b\XS
	b\Y = b\Y - b\YS
	b\B = b\B - 4
	Color b\B, b\B, b\B
	If b\B < 177 Then b\S = 1
	Rect b\X, b\Y, b\S, b\S, 1
	If b\B < 100 Then Delete b: Parts = Parts - 1
Next
End Function

Function RBank()
For a.Bank = Each Bank
	Color a\C, a\C, a\C
	If a\F = 1 Then a\Y = a\Y + 1
	Rect a\X, a\Y, a\S, a\S, 1
	If MilliSecs() >= a\T + a\L Then a\F = 1
	If a\Y >= 480 Then Delete a: Parts = Parts - 1
Next
End Function
	
